package com.baijiayun.groupclassui.chat;

import com.baijiayun.groupclassui.base.BaseGroupPresenter;
import com.baijiayun.livecore.models.LPMessageTranslateModel;
import com.baijiayun.livecore.models.imodels.IMessageModel;

import java.util.List;
import java.util.Map;


/**
 * Created by yongjiaming on 2018/10/15
 */
public interface IChatContract {

    interface View {

        void notifyOnlineUserCountChange();

        void notifyMessageDataSetChange();

        void notifyMessageItemInsert(int position, boolean isSendByMyself);

        void notifyMessageItemRemove(int index);

        void notifyForbidStatus(boolean isForbid);

        void notifyTranslateMessage(LPMessageTranslateModel translateModel);

        void notifyQuickReplyList(List<String> quickReplyList);
    }

    interface Presenter extends BaseGroupPresenter {
        void sendTranslateMessage(String message, String messageId, String classId, String userId, String fromLanguage, String toLanguage);

        Map<String, String> getExpressions();

        void reCallMessage(IMessageModel messageModel);

        int getRecallStatus(IMessageModel message);

        void getQuickReplyList();
    }
}
