package com.baijiayun.groupclassui.global;

import com.baijiayun.groupclassui.user.UserStatus;
import com.baijiayun.groupclassui.window.InteractiveBaseWindow;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.livebase.context.LPError;
import com.baijiayun.livebase.models.imodels.IUserModel;
import com.baijiayun.liveuibase.base.BaseUIConstant;

/**
 * Created by Shubo on 2018/9/12.
 */
public enum EventKey {
    /**
     * 举报窗口 {@link com.baijiayun.livecore.models.imodels.IMessageModel or Boolean}}
     */
    ReportDialog,
    /**
     * 帮助窗口 {@link Boolean}
     */
    HelpWindow,
    /**
     * 设置窗口 {@link Boolean}
     */
    SettingWindow,
    /**
     * 退出确认窗口 {@link Boolean}
     */
    CloseDialog,
    /**
     * 重新进教室 {@link LPError}
     */
    ReEnterDialog,
    /**
     * 显示聊天窗口 {@link Boolean}
     */
    DisplayChat,
    /**
     * 显示聊天飘窗 {@link Boolean}
     */
    DisplayFloatChat,
    /**
     * 启用护眼模式 {@link Boolean}
     */
    DisplayEyeCare,
    /**
     * 显示用户列表窗口 {@link UserStatus}
     */
    DisplayUserList,
    /**
     * 禁止举手状态 {@link Boolean}
     */
    ForbidHandsUp,

    /**
     * 显示分组管理窗口{@link Integer}
     */
    DisplayWindowGroupManage,

    /**
     * 显示全部解散窗口{@link Boolean}
     */
    DisplayWindowAllDissolve,

    /**
     * 选中的未分组用户{@link java.util.List}
     */
    UngroupSelectedList,

    /**
     * 未分组进入分组的用户集合{@link java.util.List}
     */
    JoiningGroupList,

    /**
     * 是否解散全部分组{@link Boolean}
     */
    GroupDissolveAllEnable,
    /**
     * 背景单次点击{@link Boolean}
     */
    BgSingleTapConfirmed,

    /**
     * 是否打开画笔选中模式
     *
     * @link Boolean
     */
    SelectModeEnable,

    /**
     * 是否打开Doodle模式
     *
     * @link Boolean
     */
    DrawLineModeEnable,
    /**
     * 是否打开图形模式
     *
     * @link view
     */
    GraphMenuEnable,

    /**
     * 图形绘制模式，格式为：
     * {@link com.baijiayun.liveuibase.widgets.toolbar.BaseGraphMenuWindow.OnShapeChangeModel}
     */
    GraphDrawEnable,

    /**
     * 激光笔
     */
    LaserDrawEnable,

    /**
     * 图片画笔
     */
    GraphBitmapEnable,
    /**
     * 选中 bitmap shape
     */
    BitmapShapeSelected,

    /**
     * 图片画笔层次切换
     */
    BitmapShapeLayerSwitch,

    /**
     * 图片画笔缩放
     */
    BitmapShapeScale,

    /**
     * 文字设置模式
     */
    DrawTextEnable,

    /**
     * 擦除图片画笔
     */
    BitmapShapeErase,

    /**
     * 图片画笔列表
     */
    BitmapShapeList,

    /**
     * 课件管理
     */
    CoursewareManageEnable,

    /**
     * 工具箱{@link android.view.View}
     */
    ToolBox,

    /**
     * 打开网页{@link Boolean}
     */
    OpenBrowserWindow,

    /**
     * 关闭网页{@link Boolean}
     */
    CloseBrowserWindow,

    /**
     * 关闭网页窗口{@link Boolean}
     */
    CloseBrowserDialog,

    /**
     * 打开随机选人窗口{@link com.baijiayun.livecore.models.LPRandomSelectValueModel}
     */
    OpenRandomSelectWindow,

    /**
     * 弱网提示窗口{@link String}
     */
    NetworkTipsDialog,

    /**
     * 分组管理{@link Boolean}
     */
    GroupManageLayout,

    /**
     * h5文档课件删除
     */
    CoursewareH5DocumentDeleteConfirm,

    /**
     * 上传文件路径返回
     * {@link java.util.Map<>}
     * key : {@link BaseUIConstant.UploadType}
     * value : String -- path 路径
     */
    UploadPPTPath,

    /**
     * 发送编辑文字
     */
    DrawTextSend,

    /**
     * 清除文字画笔、输入框等
     */
    ClearEditText,

    /**
     * 改变doodle画笔线宽度
     */
    DrawWidthChange,

    /**
     * 改变定制图形画笔线宽度
     */
    CustomGraphWidthChange,

    /**
     * 擦除画笔(框选删除)
     */
    GraphSelectEraseMode,

    /**
     * 擦除画笔（橡皮擦擦除）
     */
    GraphEraseMode,

    /**
     * 清屏画笔
     */
    GraphEraseAll,

    /**
     * 画笔颜色改变{@link com.baijiayun.liveuibase.widgets.toolbar.ColorSelectData}
     */
    DrawColorChange,

    /**
     * 所有画笔颜色更新{@link String}
     */
    DrawColorAllChange,

    /**
     * 缓存的画笔颜色.{@link java.util.Map<String,String>}
     */
    CachePaintColorMap,

    /**
     * 自己是否修改过画笔颜色{@link Boolean}
     */
    IsChangedPaintColor,

    /**
     * 改变编辑文字大小
     */
    DrawTextSizeChange,

    /**
     * 开启文档窗口最大化
     */
    SetMaximumWindowOn,

    /**
     * 关闭文档窗口最大化
     */
    SetMaximumWindowOff,

    /**
     * 关闭文档窗口 （未删除文档）
     */
    ClosePPTWindow,

    /**
     * 文档窗口 移动和缩放
     */
    RepositionPPTWindow,
    /**
     * 打开网页窗口 移动和缩放
     */
    RepositionWebpage,
    /**
     * 打开网页窗口 打开
     */
    AddWebpage,

    /**
     * 文档窗口 bringToFront
     */
    PPTWindowBringToFront,
    /**
     * 文档窗口 bringToFront 不发信令
     */
    PPTWindowBringToFrontLocal,

    /**
     * 上课时检查同步预览 PPT 为正式 PPT
     */
    CheckSyncPreviewDoc,

    /**
     * 关闭视频弹窗{@link String}
     */
    CloseVideoWindow,

    /**
     * 重置工具栏状态
     */
    ResetToolbarStatus,

    /**
     * 移动视频弹窗{@link com.baijiayun.livecore.models.LPPlayerViewUpdateModel.PlayerPosition}
     */
    MoveVideoWindow,

    /**
     * 置顶视频弹窗{@link com.baijiayun.livecore.models.LPPlayerViewUpdateModel.PlayerPosition}
     */
    StickVideoWindow,

    /**
     * 同步视频弹窗{@link java.util.List<com.baijiayun.groupclassui.model.SyncPlayerViewModel>}
     */
    SyncPlayerView,

    /**
     * 座位席视频拖动到黑板区域{@link com.baijiayun.groupclassui.model.PlayerViewActionModel}
     */
    PlayerViewAdd,

    /**
     * 视频从黑板区域回到座位席{@link com.baijiayun.groupclassui.window.video.VideoWindow}
     */
    PlayerViewRemove,

    /**
     * 设置全屏Window {@link InteractiveBaseWindow}
     */
    SetFullScreenWindowOn,

    /**
     * 换下的全屏window {@link InteractiveBaseWindow}
     */
    SetFullScreenWindowOff,

    RemoveFullScreenWindow,

    /**
     * 开启最小化窗口
     */
    MinimizeWindowOn,

    /**
     * 关闭最小化窗口
     */
    MinimizeWindowOff,
    /**
     * 最小化窗口缓存
     */
    MinimizeWindows,

    /**
     * 接收到新消息
     */
    ChatMessageReceived,

    /**
     * 视频弹出菜单{@link com.baijiayun.groupclassui.model.VideoMenuControlModel}
     */
    ShowVideoMenu,

    /**
     * 隐藏视频菜单.{@link IUserModel}
     */
    HideVideoMenu,

    /**
     * 用户进入或退出时，视频位置发生变化时,重新定位视频菜单.
     */
    RepositionVideoMenu,

    /**
     * 全部 doc View list{@link java.util.List<com.baijiayun.livecore.models.LPDocViewElementModel>}
     */
    AllDocViewList,

    /**
     * 全部 player_view{@link java.util.List<com.baijiayun.livecore.models.LPPlayerViewUpdateModel.PlayerPosition>}
     */
    AllPlayerViewList,


    AllSnippetViewList,

    /**
     * 激光笔画布是否全屏
     */
    LaserLayerFullScreen,

    /**
     * 展示奖励动画
     */
    ShowAward,

    /**
     * 奖励动画中转
     */
    ShowAwardTransfer,

    /**
     * 黑板页数提示
     */
    ReminderBlackboardPage,

    /**
     * 提示消息
     */
    ReminderMessage,

    /**
     * 提示错误消息
     */
    ReminderErrorMessage,

    /**
     *
     */
    ClearToolbarWindow,

    /**
     * 踢人二次确认
     */
    KickOutConfirm,

    /**
     * 主动触发一次snippet_pull_req打开对应状态的sbbWindow
     */
    SbbOpenWindow,

    /**
     * 关闭当前所有sbbWindow，不发广播同步状态
     */
    SbbCloseAllLocalWindow,

    /**
     * 开启小黑板画笔工具栏
     * 0：关闭，1：开启，-1：延时关闭
     */
    SbbShowToolBarWindow,
    /**
     * 学生打开的小黑板数量
     */
    SbbWindowCount,

    /**
     * SbbAddWindow
     */
    SbbAddWindow,

    /**
     * 关闭小黑板
     */
    SbbCloseWindow,

    /**
     * 重定位小黑板
     */
    SbbRepositionWindow,

    /**
     * 小黑板移动到前台
     */
    SbbBringToFront,

    /**
     * 显示小黑板名称
     */
    SbbShowName,

    /**
     * 弱网丢包率通知
     */
    NetWorkLossRateNotify,

    /**
     * 抢答器
     */
    Responder,
    /**
     * 抢答器记录
     */
    ResponderRecord,
    /**
     * 老师定时器{@link Boolean}
     */
    TeacherTimerWindow,

    /**
     * 老师答题器{@link Boolean}
     */
    TeacherAnswererWindow,
    /**
     * 打开答题器{@link Boolean}
     */
    StudentAnswererWindow,

    /**
     * 激光笔显示状态
     */
    LaserShowState,

    /**
     * 打开表情报告Activity
     */
    OpenExpressionReportActivity,

    /**
     * 关闭表情报告窗口
     */
    CloseExpressionReportActivity,
    /**
     * 关闭测验窗口
     */
    CloseQuizDialog,

    /**
     * 编辑文字画笔
     */
    EditTextShape,

    /**
     * 组点赞
     */
    GroupAward,

    /**
     * 画笔被选中
     */
    Action2ShapeSelected,

    /**
     * 画笔工具栏item选中事件
     */
    ToolbarItemSelected,

    /**
     * 如果pptview不为空，刷新pptview
     */
    UpdatePPTView,


    /**
     * 控制小班课是否显示"视频复位"按钮
     */
    ResumeButton,

    /**
     * 小班课视频一键归位，移除黑板区视频
     */
    RemoveAllBlackboardVideoWindow,

    /**
     * 视频窗口移动到黑板区域
     * {@link com.baijiayun.groupclassui.window.video.VideoWindow}
     */
    VideoWindowToBlackboard,
    /**
     * 视频窗口移动到黑板区域并且放到最大
     * {@link com.baijiayun.groupclassui.window.video.VideoWindow}
     */
    VideoWindowToBlackboardAndMax,
    /**
     * 扫码直播{@link Boolean}
     */
    ShowQrCode,
    /**
     * 提示自己已上台或者坐席已满{@link Boolean}
     * false 自己下台了
     */
    NoteSelfActive,
    /**
     * 自习室切换{@link LPConstants.StudyRoomMode}
     */
    StudyRoomSwitch,
    /**
     * 自习室排行{@link java.util.List<com.baijiayun.livecore.models.LPStudyUserStatus>}
     */
    StudyRankList,
    /**
     * 自己是否在挂机{@link Boolean}
     */
    StudyStatusHangUp,
    /**
     * 重进教室{@link String}
     */
    StudyReEnterRoom,
    /**
     * 点名{@link Boolean}
     */
    RollCallWindow,
    /**
     * 点名蓝点提示{@link Boolean}
     */
    ShowRollCallDot,
    /*
     * 请求帮助{@link Boolean}
     * 多个请求
     */
    StudyStatusForHelping,
    /**
     * 自己是否在辅导中tutor_id{@link String}
     */
    StudyStatusTutor,
    /*
     * 打开提问界面{@link com.baijiayun.groupclassui.window.study.DisplayStudyQuestion}
     */
    DisplayStudyQuestion,
    /**
     * 图片预览{@link String}
     */
    DisplayImgPreview,
    /**
     * pptWindows缓存
     */
    PPTWindows,
    /**
     * 全屏的宽度
     */
    FullScreenWidth,
    /**
     * 当前最大化的PPT
     */
    MaxScreenPPTWindow,
    /**
     * 当前全屏PPT
     */
    FullScreenPPTWindow,
    /**
     * PPTTabLaye
     */
    PPTTabLayer,
    /**
     * BleDialog
     */
    DisPlayBleDialog,
    /**
     * softKey
     */
    ZXYBSoftKey,
    /**
     * 新消息
     */
    NewMsgCount,
    /**
     * 积分排行
     * {@link Boolean}
     */
    ShowBonusPointWindow,
    /**
     * 打开媒体课件播放器{@link com.baijiayun.livecore.models.courseware.LPMediaCoursewareModel}
     */
    openMediaPlayerWindow,
    /**
     * 关闭媒体课件播放器 {@link Boolean}
     */
    closeMediaPlayerWindow,
    /**
     * 隐藏其他学生视频(同只看老师，只是这个是学生自己控制){@link Boolean}
     */
    HideOtherStudentVideo,
    /**
     * 播放bds(黑板导出)文件
     */
    BdsRepaint,
    /**
     * 打开 GroupMessageSendFragment
     */
    ShowMessageSendFragment,
    /**
     * 屏幕分享
     * {@link Boolean}
     */
    ScreenShare,
    /**
     * 主动关闭屏幕共享
     * {@link Boolean}
     */
    CloseScreenShare,
    /**
     * 关闭学情报告弹窗
     */
    DismissStudyReportDialog,
    /**
     * 点名倒计时
     */
    RollCallCountDown,
    /**
     * 打开学生点名
     */
    OpenStudentRollCallWindow,
    /**
     * 打开老师/助教点名
     */
    OpenAdminRollCallWindow,
    /**
     * 关闭点名（不区分老师学生）
     */
    CloseRollCallWindow,
    /**
     * 音乐模式
     */
    MusicMode,
    /**
     * 预览课件
     */
    DocPreview,
    /**
     * 打开转盘
     */
    Turntable,
    /**
     * 隐藏坐席区窗口
     */
    PlayerViewHide,
}
