package com.baijiayun.groupclassui.user;

import android.app.Activity;
import android.content.Context;
import android.graphics.Typeface;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.ExpandableListView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.global.EventCode;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.groupclassui.global.RouterListener;
import com.baijiayun.groupclassui.util.LinearLayoutWrapManager;
import com.baijiayun.livebase.widgets.dialog.CommonDialog;
import com.baijiayun.livecore.models.LPGroupItem;
import com.baijiayun.livebase.models.imodels.IUserModel;

/**
 * Created by yongjiaming on 2018/10/11
 * 全部在线用户列表
 */
public class AllOnlineUserListFragment extends Fragment implements IUserContract,IUserInteractionListener {

    private OnlineUserPresenter onlineUserPresenter;
    private RecyclerView mRlvInteractiveClassBlacklist;
    private ExpandableListView activeListView, unActiveListView;
    private TextView activeUserTextView, unActiveUserTextView, mTvInteractiveOnlineTitsle;
    private LinearLayout activeUserLayout, unActiveUserLayout;
    private RelativeLayout mRlClassBlacklist;
    private View mIvInteractiveClassUpIcon, mIvInteractiveClassDownIcon, mIvInteractiveClassBlacklistIcon,mIvFreeBlockAll;
    private RelativeLayout mRlInteractiveClassBlacklist;
    private LinearLayout activeUserContainer,unActiveUserContainer;
    private View viewActiveDiv,viewUnActiveDiv, viewKickoutDiv;

    private BlockListRecyclerViewAdapter blockListRecyclerViewAdapter;
    private ActiveGroupExpandAdapter activeGroupExpandAdapter;
    private UnActiveGroupExpandAdapter unActiveGroupExpandAdapter;
    private IRouter iRouter;
    private int expandType = 0;
    public static final int EXPAND_ACTIVE = 0;
    public static final int EXPAND_UNACTIVE = 1;
    public static final int EXPAND_KICKOUT = 2;

    /**
     * Mandatory empty constructor for the fragment manager to instantiate the
     * fragment (e.g. upon screen orientation changes).
     */
    public AllOnlineUserListFragment() {
        // do nothing
    }

    public static AllOnlineUserListFragment newInstance() {
        return new AllOnlineUserListFragment();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof RouterListener) {
            iRouter = ((RouterListener) context).getRouter();
        }
    }

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View localView = inflater.inflate(R.layout.bjysc_fragment_online_list, container, false);

        Context context = localView.getContext();
        setPresenter(new OnlineUserPresenter(this));
        blockListRecyclerViewAdapter = new BlockListRecyclerViewAdapter(onlineUserPresenter, this);
        activeGroupExpandAdapter = new ActiveGroupExpandAdapter(onlineUserPresenter, this);
        unActiveGroupExpandAdapter = new UnActiveGroupExpandAdapter(onlineUserPresenter, this);
        mIvInteractiveClassUpIcon = localView.findViewById(R.id.bjysc_ic_expand_online_up);
        mIvInteractiveClassDownIcon = localView.findViewById(R.id.bjysc_ic_expand_online_down);
        mIvInteractiveClassBlacklistIcon = localView.findViewById(R.id.bjysc_ic_expand_online_kickout);
        activeUserTextView = localView.findViewById(R.id.bjysc_online_up_text);
        unActiveUserTextView = localView.findViewById(R.id.bjysc_online_down_text);
        activeListView = localView.findViewById(R.id.active_listview);
        activeUserContainer = localView.findViewById(R.id.bjysc_user_container_online_up);
        unActiveUserContainer = localView.findViewById(R.id.bjysc_user_container_online_down);
        viewActiveDiv = localView.findViewById(R.id.view_space_active);
        viewUnActiveDiv = localView.findViewById(R.id.view_space_unactive);
        viewKickoutDiv = localView.findViewById(R.id.view_space_kick_out);
        mIvFreeBlockAll = localView.findViewById(R.id.bjysc_iv_remove_block_list);
        activeListView.setAdapter(activeGroupExpandAdapter);

        activeUserLayout = localView.findViewById(R.id.bjysc_active_user_button);
        unActiveUserLayout = localView.findViewById(R.id.bjysc_un_active_user_button);
        unActiveListView = localView.findViewById(R.id.unactive_listview);
        unActiveListView.setAdapter(unActiveGroupExpandAdapter);
        unActiveUserContainer.findViewById(R.id.tv_user_camera).setVisibility(View.GONE);
        unActiveUserContainer.findViewById(R.id.tv_user_mic).setVisibility(View.GONE);
        showStudyRoomItems();
        activeListView.setOnGroupExpandListener(groupPosition -> {
            final Object group = activeGroupExpandAdapter.getGroup(groupPosition);
            if (group == null) {
                return;
            }
            LPGroupItem lpGroupItem = (LPGroupItem) group;
            if (lpGroupItem.id == 0) {
                return;
            }
            for (int i = 0; i < activeGroupExpandAdapter.getGroupCount(); i++) {
                LPGroupItem item = (LPGroupItem) activeGroupExpandAdapter.getGroup(i);
                if (i != groupPosition && item != null && item.id != 0) {
                    activeListView.collapseGroup(i);
                }
            }
            onlineUserPresenter.updateGroupInfo(lpGroupItem.id);
        });
        unActiveListView.setOnGroupExpandListener(groupPosition -> {
            final Object group = unActiveGroupExpandAdapter.getGroup(groupPosition);
            if (group == null) {
                return;
            }
            LPGroupItem lpGroupItem = (LPGroupItem) group;
            if (lpGroupItem.id == 0) {
                return;
            }
            for (int i = 0; i < unActiveGroupExpandAdapter.getGroupCount(); i++) {
                LPGroupItem item = (LPGroupItem) unActiveGroupExpandAdapter.getGroup(i);
                if (i != groupPosition && item != null && item.id != 0) {
                    unActiveListView.collapseGroup(i);
                }
            }
            onlineUserPresenter.updateGroupInfo(lpGroupItem.id);
        });
        activeListView.setOnScrollListener(new AbsListView.OnScrollListener() {
            @Override
            public void onScrollStateChanged(AbsListView view, int scrollState) {
                if (scrollState == AbsListView.OnScrollListener.SCROLL_STATE_IDLE) {
                    if (view.getLastVisiblePosition() == activeListView.getCount() - 1 && activeListView.getCount() > 10) {
                        onlineUserPresenter.loadMore();
                    }
                }
            }

            @Override
            public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
                // do nothing
            }
        });
        unActiveListView.setOnScrollListener(new AbsListView.OnScrollListener() {
            @Override
            public void onScrollStateChanged(AbsListView view, int scrollState) {
                if (scrollState == AbsListView.OnScrollListener.SCROLL_STATE_IDLE) {
                    if (view.getLastVisiblePosition() == unActiveListView.getCount() - 1 && unActiveListView.getCount() > 10) {
                        onlineUserPresenter.loadMore();
                    }
                }
            }

            @Override
            public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
                // do nothing
            }
        });
        mIvFreeBlockAll.setOnClickListener(v -> showConfirmFreeAll());
        //黑名单
        mRlClassBlacklist = localView.findViewById(R.id.ll_interactive_class_blacklist);
        mTvInteractiveOnlineTitsle = localView.findViewById(R.id.tv_interactive_online_title);
        mRlvInteractiveClassBlacklist = localView.findViewById(R.id.rlv_interactive_class_blacklist);
        mRlInteractiveClassBlacklist = localView.findViewById(R.id.rl_interactive_class_blacklist);
        mRlvInteractiveClassBlacklist.setLayoutManager(new LinearLayoutWrapManager(context));
        mRlvInteractiveClassBlacklist.setAdapter(blockListRecyclerViewAdapter);


        if (!onlineUserPresenter.isAdmin()) {
            mRlClassBlacklist.setVisibility(View.GONE);
        }

        activeUserLayout.setOnClickListener((View view) -> expandLayout(EXPAND_ACTIVE));

        unActiveUserLayout.setOnClickListener((View view) -> expandLayout(EXPAND_UNACTIVE));
        mRlClassBlacklist.setOnClickListener((View view) -> expandLayout(EXPAND_KICKOUT));

        //默认打开台上成员列表
        expandLayout(EXPAND_ACTIVE);
        notifyDataChange();
        return localView;
    }

    private void showStudyRoomItems() {
        //自习室非辅导模式隐藏画笔ppt和屏幕分享
        //presenter中先订阅会回调会先于view初始化
        if (activeUserContainer == null) {
            return;
        }
        int visibility = iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomMode().isGalleryLayout() ? View.GONE : View.VISIBLE;
        activeUserContainer.findViewById(R.id.tv_user_ppt_auth).setVisibility(visibility);
        activeUserContainer.findViewById(R.id.tv_user_ppt_paint).setVisibility(visibility);
        activeUserContainer.findViewById(R.id.tv_user_screen_share).setVisibility(visibility);
        unActiveUserContainer.findViewById(R.id.tv_user_ppt_auth).setVisibility(visibility);
        unActiveUserContainer.findViewById(R.id.tv_user_ppt_paint).setVisibility(visibility);
        unActiveUserContainer.findViewById(R.id.tv_user_screen_share).setVisibility(visibility);

        if (!onlineUserPresenter.isAdmin()) {
            activeUserContainer.setVisibility(View.GONE);
            unActiveUserContainer.setVisibility(View.GONE);
        }
    }

    private void showConfirmFreeAll() {
        if (getContext() instanceof Activity) {
            Activity activity = (Activity) getContext();
            if (activity.isDestroyed() || activity.isFinishing()) {
                return;
            }
        } else {
            return;
        }
        new CommonDialog(getContext(), CommonDialog.ChoiceMode.Double_Blue)
                .setMainDisplayText(getString(R.string.bjysc_blocked_user_free_all))
                .setNegative(getString(R.string.bjysc_about_cancel), ((dialog, which) -> {
                    dialog.dismiss();
                }))
                .setPositive(getString(R.string.bjysc_all_lift), ((dialog, which) -> {
                    if (onlineUserPresenter != null) {
                        onlineUserPresenter.setBlockedUserFreeAll();
                    }
                    dialog.dismiss();
                }))
                .show();
    }

    private void expandLayout(int expandType) {
        this.expandType = expandType;
        boolean isActive = expandType == EXPAND_ACTIVE;
        boolean isUnActive = expandType == EXPAND_UNACTIVE;
        boolean isKickout = expandType == EXPAND_KICKOUT;
        activeListView.setVisibility(isActive ? View.VISIBLE : View.GONE);
        unActiveListView.setVisibility(isUnActive ? View.VISIBLE : View.GONE);
        mRlInteractiveClassBlacklist.setVisibility(isKickout?View.VISIBLE:View.GONE);

        mIvInteractiveClassUpIcon.setVisibility(isActive ? View.GONE : View.VISIBLE);
        mIvInteractiveClassDownIcon.setVisibility(isUnActive ? View.GONE : View.VISIBLE);
        mIvInteractiveClassBlacklistIcon.setVisibility(isKickout ? View.GONE : View.VISIBLE);

        zoomTextWidth(activeUserTextView, isActive);
        zoomTextWidth(unActiveUserTextView, isUnActive);

        if (onlineUserPresenter.isAdmin()) {
            activeUserContainer.setVisibility(isActive ? View.VISIBLE : View.GONE);
            unActiveUserContainer.setVisibility(isUnActive ? View.VISIBLE : View.GONE);
        }

        viewActiveDiv.setVisibility(isActive ? View.VISIBLE : View.GONE);
        viewUnActiveDiv.setVisibility(isUnActive ? View.VISIBLE : View.GONE);
        viewKickoutDiv.setVisibility(isKickout ? View.VISIBLE : View.GONE);
        mIvFreeBlockAll.setVisibility(isKickout && onlineUserPresenter.getBlockedUserListCount() > 0 ? View.VISIBLE : View.GONE);

        activeUserTextView.setTypeface(isActive ? Typeface.DEFAULT_BOLD : Typeface.DEFAULT);
        unActiveUserTextView.setTypeface(isUnActive ? Typeface.DEFAULT_BOLD : Typeface.DEFAULT);
        mTvInteractiveOnlineTitsle.setTypeface(isKickout ? Typeface.DEFAULT_BOLD : Typeface.DEFAULT);
    }
    /**
     * 默认title=100dp,放大152dp
     * @param textView
     * @param zoom 是否是放大
     */
    private void zoomTextWidth(TextView textView,boolean zoom) {
        if (getContext() == null) {
            return;
        }
        final ViewGroup.LayoutParams layoutParams = textView.getLayoutParams();
        if (layoutParams instanceof  LinearLayout.LayoutParams) {
            LinearLayout.LayoutParams params = (LinearLayout.LayoutParams) layoutParams;
            if (zoom) {
                params.width = getContext().getResources().getDimensionPixelSize(R.dimen.bjysc_window_user_title_width);
            } else {
                params.width = getContext().getResources().getDimensionPixelSize(R.dimen.bjysc_window_user_title_width_normal);
            }
        }
    }

    private void setPresenter(OnlineUserPresenter presenter) {
        this.onlineUserPresenter = presenter;
        onlineUserPresenter.setRouter(iRouter);
        onlineUserPresenter.subscribe();
    }

    private void notifyDataChange() {
        //自习室信令订阅就有view未初始化
        if (activeUserTextView == null) {
            return;
        }
        activeUserTextView.setText(getString(R.string.active_user, onlineUserPresenter.getUpUserCount()));
        unActiveUserTextView.setText(getString(R.string.un_active_user, onlineUserPresenter.getDownUserCount()));
        mTvInteractiveOnlineTitsle.setText(getString(R.string.string_blacklist, onlineUserPresenter.getBlockedUserListCount()));
        activeGroupExpandAdapter.setDatas(onlineUserPresenter.getActiveGroupList());
        unActiveGroupExpandAdapter.setDatas(onlineUserPresenter.getUnActiveGroupList());
        LPGroupItem item = (LPGroupItem) activeGroupExpandAdapter.getGroup(0);
        if (item != null && item.id == 0) {
            activeListView.expandGroup(0);
        }
        LPGroupItem lpGroupItem = (LPGroupItem) unActiveGroupExpandAdapter.getGroup(0);
        if (lpGroupItem != null && lpGroupItem.id == 0) {
            unActiveListView.expandGroup(0);
        }
        blockListRecyclerViewAdapter.notifyDataSetChanged();
        mIvFreeBlockAll.setVisibility(expandType == EXPAND_KICKOUT
                && onlineUserPresenter.getBlockedUserListCount() > 0 ? View.VISIBLE : View.GONE);
    }


    @Override
    public void upOrDownSeatContainer(IUserModel userModel, boolean isShowOnSeatContainer) {
        onlineUserPresenter.upOrDownFromSeatContainer(userModel, isShowOnSeatContainer);
    }

    @Override
    public void forbidChat(IUserModel userModel) {
        onlineUserPresenter.forbidChat(userModel);
    }

    @Override
    public void unForbidChat(IUserModel userModel) {
        onlineUserPresenter.unForbidChat(userModel);
    }

    @Override
    public void kickUserOut(IUserModel userModel) {
        onlineUserPresenter.kickOutUser(userModel);
    }

    public void showActiveUser() {
        if (activeListView != null && unActiveListView != null) {
            expandLayout(EXPAND_ACTIVE);
        }
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        if (onlineUserPresenter != null) {
            onlineUserPresenter.destroy();
        }
    }

    @Override
    public void notifyOnlineUserDataSetChange() {
        notifyDataChange();
    }

    @Override
    public void notifyOnlineUserCountChange() {
        // do nothing
    }

    @Override
    public void notifyHandsUpUserDataSetChange() {
        // do nothing
    }

    @Override
    public void notifyActiveUserDataChange() {
        // do nothing
    }

    @Override
    public void notifySpeakApplyResult() {
        // do nothing
    }

    @Override
    public void notifyForbidStatus() {
        notifyDataChange();
    }

    @Override
    public void notifyUserDataChange() {
        notifyDataChange();
    }

    @Override
    public void notifyForbidHandUp(boolean isForbid) {
        // do nothing
    }

    @Override
    public void notifyCurrentSeatFull() {
        if (iRouter != null) {
            iRouter.getPublishSubjectByKey(EventCode.NotifyCurrentSeatFull).onNext(true);
        }
    }

    @Override
    public void showBlockedUserFreeAllUI() {
        // do nothing
    }

    @Override
    public void notifyStudyRoomSwitch() {
        showStudyRoomItems();
    }
}
