package com.baijiayun.groupclassui.user;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.baijiayun.groupclassui.R;
import com.baijiayun.livebase.models.LPUserModel;

/**
 * 黑名单Adapter
 */
public class BlockListRecyclerViewAdapter extends RecyclerView.Adapter<BlockListRecyclerViewAdapter.ViewHolder>{
    private IUserContract listener;
    private OnlineUserPresenter presenter;

    BlockListRecyclerViewAdapter(OnlineUserPresenter presenter, IUserContract listener) {
        this.presenter = presenter;
        this.listener = listener;
    }

    @NonNull
    @Override
    public BlockListRecyclerViewAdapter.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.bjysc_item_kickout_user, parent, false);
        return new ViewHolder(view);
    }


    @Override
    public void onBindViewHolder(@NonNull final ViewHolder holder, int position) {

        LPUserModel userModel = (LPUserModel) presenter.getBlockList(position);
        holder.userNameTv.setText(userModel.getName());
        holder.ivRemoveBlocklist.setOnClickListener((View view) -> presenter.removeBlockList(userModel.number));
    }

    @Override
    public int getItemCount() {
        return presenter.getBlockedUserListCount();
    }

    static class ViewHolder extends RecyclerView.ViewHolder {

        TextView userNameTv;
        ImageView ivRemoveBlocklist;

        ViewHolder(View view) {
            super(view);
            userNameTv = view.findViewById(R.id.tv_user_name);
            ivRemoveBlocklist = view.findViewById(R.id.iv_remove_blocklist);
            ivRemoveBlocklist.setVisibility(View.VISIBLE);
        }
    }
}
