package com.baijiayun.groupclassui.util;

import android.text.TextUtils;

import com.baijiayun.groupclassui.window.video.VideoWindow;
import com.baijiayun.livecore.utils.LPMediaIdUtils;

/**
 * Created by Shubo on 2019/3/21.
 */
public class FECompatUtil {

    public static String getMediaIdFromFEUserId(String userId) {
        if (TextUtils.isEmpty(userId)) {
            return "";
        }
        if (userId.contains("_")) {
            return userId;
        }
        String suffix = userId.substring(userId.length() - 1);
        suffix = LPMediaIdUtils.transferMediaId(suffix);
        return suffix.equals("0") ? userId : userId.substring(0, userId.length() - 1).concat("0_").concat(suffix);
    }

    /**
     * 发送信令要调此函数转换，sdk内部的session和其它端不一致
     * @param mediaId
     * @return
     */
    public static String getIOSMediaIdFromMediaId(String mediaId) {
        if (TextUtils.isEmpty(mediaId)) {
            return "";
        }
        if (!mediaId.contains("_")) {
            return mediaId;
        }
        String suffix = mediaId.substring(mediaId.length() - 1);
        suffix = LPMediaIdUtils.transferBackMediaId(suffix);
        return mediaId.substring(0, mediaId.indexOf("_") - 1).concat(suffix);
    }

    public static boolean checkVideoWindowMediaId(VideoWindow videoWindow, String mediaId) {
        return isTargetWindow(videoWindow,mediaId) && !videoWindow.isDestroyed();
    }

    /**
     * 仅判断是否是目标videoWindow与checkVideoWindowMediaId区别
     * @param videoWindow
     * @param mediaId
     * @return
     */
    public static boolean isTargetWindow(VideoWindow videoWindow, String mediaId) {
        if (videoWindow == null || mediaId == null) {
            return false;
        }
        boolean isScreenShare = videoWindow.isScreenShare();
        if (isScreenShare) {
            return mediaId.equals(videoWindow.getUserId());
        } else {
            return mediaId.equals(videoWindow.getMediaId());
        }
    }

    public static String getMediaId(String userId, int session) {
        if (TextUtils.isEmpty(userId)) {
            return "";
        }
        //兼容userId实际上已经带了session
        if(userId.contains("_")){
            return userId;
        }
        // 11111 0 -> 11110_1
        if (userId.endsWith("1")) {
            userId = userId.substring(0, userId.length() - 1).concat("0");
        }
        return session == 0 ? userId : userId.concat("_").concat(String.valueOf(session));
    }
}
