package com.baijiayun.groupclassui.widget;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Build;
import androidx.annotation.RequiresApi;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.widget.ScrollView;


/**
 * 布局：外面暂时用scrollview吧，里面使用LinearLayout...viewpager吧
 * 如果是上下滑动，外层拦截。如果是左右滑动.
 * Created by Dujuncan on 2018/09/29.
 */
public class GroupManageScrollView extends ScrollView {

    private final String TAG = GroupManageScrollView.class.getCanonicalName();
    private boolean mIsIntercept = true;
    private float currX, currY;

    public GroupManageScrollView(Context context) {
        super(context);
        init();
    }

    public GroupManageScrollView(Context context, AttributeSet attrs) {
        super(context, attrs);
        init();
    }

    public GroupManageScrollView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init();
    }

    @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
    public GroupManageScrollView(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
        init();
    }

    @Override
    public boolean onInterceptTouchEvent(MotionEvent ev) {
        super.onInterceptTouchEvent(ev);
        switch (ev.getAction()) {
            case MotionEvent.ACTION_DOWN:
                currX = ev.getRawX();
                currY = ev.getRawY();
                mIsIntercept = false;
                break;
            case MotionEvent.ACTION_MOVE:
                float offsetX = Math.abs(ev.getRawX() - currX);
                float offsetY = Math.abs(ev.getRawY() - currY);
                Log.d(TAG, "是否拦截？onInterceptTouchEvent: " + (offsetY > offsetX));
                mIsIntercept = offsetY > offsetX;
                break;
            default:
                break;
        }
        return mIsIntercept;
    }

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public boolean onTouchEvent(MotionEvent ev) {
        super.onTouchEvent(ev);
        switch (ev.getAction()) {
            case MotionEvent.ACTION_DOWN:
                currX = ev.getRawX();
                currY = ev.getRawY();
                Log.d(TAG, "处理 onTouchEvent:down");
                break;
            case MotionEvent.ACTION_MOVE:
                float offsetX = Math.abs(ev.getRawX() - currX);
                float offsetY = Math.abs(ev.getRawY() - currY);
                Log.d(TAG, "onTouchEvent:move " + ev.getRawX() + "...." + ev.getRawY() + "....上下距离=" + offsetY + "...左右距离=" + offsetX);
                break;
            case MotionEvent.ACTION_UP:
                mIsIntercept = false;
                break;
            default:
                break;
        }
        return true;
    }

    private void init() {
        // do nothing
    }
}
