package com.baijiayun.groupclassui.widget;

import android.annotation.SuppressLint;
import android.content.Context;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.viewpager.widget.ViewPager;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;

/**
 * 分组ViewPager
 * Created by Dujuncan on 2018/09/29.
 */
public class GroupManageViewPager extends ViewPager {

    private final String TAG = GroupManageViewPager.class.getCanonicalName();

    private float currX, currY;

    public GroupManageViewPager(@NonNull Context context) {
        super(context);
    }

    public GroupManageViewPager(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public boolean onTouchEvent(MotionEvent ev) {
        boolean isHandle = false;
        switch (ev.getAction()) {
            case MotionEvent.ACTION_DOWN:
                currX = ev.getRawX();
                currY = ev.getRawY();
                isHandle = true;
                Log.d(TAG, "onTouchEvent: down " + isHandle);
                break;
            case MotionEvent.ACTION_MOVE:
                float offsetX = Math.abs(ev.getRawX() - currX);
                float offsetY = Math.abs(ev.getRawY() - currY);
                isHandle = false;
                Log.d(TAG, "onTouchEvent: Move =" + isHandle + "...左右移动" + offsetX);
                break;
            default:
                break;
        }
        return isHandle ? isHandle : super.onTouchEvent(ev);
    }
}
