package com.baijiayun.groupclassui.window.bottommenu;

import com.baijiayun.groupclassui.base.BaseGroupPresenter;
import com.baijiayun.livebase.base.BaseView;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.livecore.models.roomresponse.LPResCloudRecordModel;

/**
 * Created by Shubo on 2018/9/21.
 */
interface BottomMenuContract {

    interface View extends BaseView<Presenter> {

        void showStudentView();

        void showTeacherView();

        void showAssistantView();

        void showRecordingStatus(LPResCloudRecordModel recordStatus);

        void showForbidHandsUpStatus(boolean isForbidden);

        void showUserListWindowShowingStatus(boolean isShowing);

        void showChatWindowShowingStatus(boolean isShowing);

        void showFloatChatWindowShowingStatus(boolean isShowing);

        void showGalleryModel(boolean isOn);

        void showStudyGalleryModel(LPConstants.StudyRoomMode studyRoomMode);

        void showChatWindowRedPoint(boolean isVisible);

        void showCloudRecordHint();

        void showShortTermClassAlreadyHasPlayback();

        void showCloudRecordRestartDialog();

        void showMicStatus(boolean isMicOn);

        void showCameraStatus(boolean isCameraOn);

        void showUserListStatus(boolean isShow);

        /**
         * 举手按钮图标状态：举手中
         * @param countDownTime 计时
         * @param total 总计
         */
        void showSpeakApplyCountDown(int countDownTime, int total);

        /**
         * 举手按钮图标状态：普通（取消举手、取消禁言）
         */
        void showSpeakApplyNormal();

        /**
         * 举手按钮图标状态：不可用（收到禁言、发言中）
         */
        void showSpeakApplyDisable();

        void showHandsUpRemind(int count, String name);

        void hideHandsUpCount();

        void showCloudRecordButton(boolean cloudRecord);

        void showMuteAllStateChange(boolean mute);

        void showBonusPointsAdd(Integer integer);
    }

    interface Presenter extends BaseGroupPresenter {

        void navigateToGalleryMode();

        void changeRecordStatus();

        void changeForbidHandsUpStatus();

        void navigateToUserList();

        void navigateToChat();

        void navigateToHomework();

        void navigateToEyeCare(boolean enableEyeCare);

        void speakApply();

        void stopCloudRecord();

        void pauseCloudRecord();

        void startNewCloudRecord();

        void continueCloudRecord();

        LPResCloudRecordModel getCloudRecordStatus();

        void quickMuteAllStudentMic(boolean mute);

        void exit();

        boolean showCloudRecord();

        void navigateToBonusPoints();

        boolean isMediaCoursewarePlaying();
    }
}
