package com.baijiayun.groupclassui.window.studyreport;

import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.widget.Toast;

import com.baijiayun.bjyutils.toast.ToastCompat;
import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.livebase.widgets.dialog.CommonDialog;
import com.baijiayun.livecore.context.LiveRoom;

/**
 * Created by wubanglin on 21/9/02.
 */
public class StudyReportDialogPresenter implements StudyReportDialogContract.Presenter {
    private IRouter iRouter;
    private StudyReportDialogContract.View view;
    private Context context;
    CommonDialog openStudyReportDialog;

    public StudyReportDialogPresenter(StudyReportDialogContract.View view, Context context) {
        this.view = view;
        this.context = context;
    }

    @Override
    public void setRouter(IRouter router) {
        this.iRouter = router;
    }

    @Override
    public void subscribe() {
        // do nothing
    }

    @Override
    public void unSubscribe() {
        // do nothing
    }

    @Override
    public void destroy() {
        view = null;
        iRouter = null;
    }

    @Override
    public LiveRoom getLiveRoom() {
        return iRouter.getLiveRoom();
    }

    @Override
    public void openStudyReportBrowser(String url) {
        openStudyReportDialog = new CommonDialog(context,
                CommonDialog.ChoiceMode.Double_Blue)
                .setMainDisplayText(context.getString(R.string.bjy_group_open_study_report_by_browser))
                .setNegative(context.getResources().getText(R.string.bjysc_cancel).toString()
                        , ((dialog, which) -> dialog.dismiss()))
                .setPositive(context.getString(R.string.bjysc_confirm)
                        , ((dialog, which) -> {
                            Uri uri = Uri.parse(url);
                            Intent intent = new Intent(Intent.ACTION_VIEW, uri);
                            context.startActivity(intent);
                        }));
        openStudyReportDialog.show();
    }

    @Override
    public void copyStudyReportUrl(String url) {
        try {
            //获取剪贴板管理器
            ClipboardManager cm = (ClipboardManager) context.getSystemService(Context.CLIPBOARD_SERVICE);
            // 创建普通字符型ClipData
            ClipData mClipData = ClipData.newPlainText("Label", url);
            // 将ClipData内容放到系统剪贴板里。
            cm.setPrimaryClip(mClipData);
            ToastCompat.showToast(context, "复制成功", Toast.LENGTH_SHORT);
        } catch (Exception ignored) {
            // do nothing
        }
    }

    @Override
    public void closeStudyReportDialog() {
        iRouter.getSubjectByKey(EventKey.DismissStudyReportDialog).onNext(true);
    }
}
