package com.baijiayun.groupclassui.window.toolbar;

import android.content.Context;
import android.graphics.drawable.ClipDrawable;
import android.graphics.drawable.Drawable;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.SeekBar;

import androidx.core.content.ContextCompat;

import com.baijiayun.bjyutils.drawable.DrawableBuilder;
import com.baijiayun.bjyutils.drawable.LayerDrawableBuilder;
import com.baijiayun.bjyutils.kt.UtilsKt;
import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.livebase.utils.ThemeDataUtil;
import com.baijiayun.livecore.ppt.util.ShapeUtils;

import java.util.concurrent.atomic.AtomicBoolean;

public class BitmapSettingWindow extends ToolbarBaseWindow {

    private AtomicBoolean isStartTracking = new AtomicBoolean(false);

    public BitmapSettingWindow(Context context) {
        super(context);
        init();
    }

    @Override
    protected View onCreateView(Context context) {
        view = LayoutInflater.from(context).inflate(R.layout.activity_bitmap_setting_window, null);
        FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        view.setLayoutParams(layoutParams);
        return view;
    }

    private void init(){
        final SeekBar seekBar = $.id(R.id.activity_bitmap_setting_bar).view();
        final Drawable backgroud = new DrawableBuilder()
                .line()
                .cornerRadius(UtilsKt.getDp(20))
                .solidColor(ContextCompat.getColor(context, R.color.bjysc_white))
                .strokeWidth(UtilsKt.getDp(2))
                .strokeColor(ContextCompat.getColor(context, R.color.bjysc_white))
                .build();
        final Drawable progress = new DrawableBuilder()
                .line()
                .cornerRadius(UtilsKt.getDp(20))
                .solidColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(context,R.attr.base_theme_live_product_color))
                .strokeWidth(UtilsKt.getDp(2))
                .strokeColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(context,R.attr.base_theme_live_product_color))
                .build();
        ClipDrawable clipDrawable = new ClipDrawable(progress, Gravity.CENTER, ClipDrawable.HORIZONTAL);
        seekBar.setProgressDrawable(new LayerDrawableBuilder()
                .add(backgroud)
                .add(clipDrawable)
                .build());
        ((SeekBar)$.id(R.id.activity_bitmap_setting_bar).view()).setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (isStartTracking.get()) {
                    iRouter.getSubjectByKey(EventKey.BitmapShapeScale).onNext(progress);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
                isStartTracking.set(true);
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                isStartTracking.set(false);
            }
        });

        $.id(R.id.activity_bitmap_setting_down_layer).clicked(v -> iRouter.getSubjectByKey(EventKey.BitmapShapeLayerSwitch).onNext(ShapeUtils.SWITCH_TO_DOWN_LAYER));

        $.id(R.id.activity_bitmap_setting_to_bottom).clicked(v -> iRouter.getSubjectByKey(EventKey.BitmapShapeLayerSwitch).onNext(ShapeUtils.SWITCH_TO_BOTTOM_LAYER));

        $.id(R.id.activity_bitmap_setting_up_layer).clicked(v -> iRouter.getSubjectByKey(EventKey.BitmapShapeLayerSwitch).onNext(ShapeUtils.SWITCH_TO_UP_LAYER));

        $.id(R.id.activity_bitmap_setting_to_top).clicked(v -> iRouter.getSubjectByKey(EventKey.BitmapShapeLayerSwitch).onNext(ShapeUtils.SWITCH_TO_TOP_LAYER));

        $.id(R.id.activity_bitmap_setting_clear).clicked(v -> iRouter.getSubjectByKey(EventKey.BitmapShapeErase).onNext(true));
    }
}
