package com.baijiayun.groupclassui.window.toolbar;

import android.content.Context;

import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.liveuibase.widgets.toolbar.BaseDrawWidthSettingWindow;
import com.baijiayun.liveuibase.widgets.toolbar.ColorSelectData;
import com.baijiayun.liveuibase.widgets.toolbar.WidthSelectData;

import io.reactivex.disposables.Disposable;

public class DrawWidthSettingWindow extends BaseDrawWidthSettingWindow {
    private IRouter iRouter;
    private boolean showMarker;
    private Disposable disposableOfColorAllChange;

    public DrawWidthSettingWindow(boolean showMarker, Context context, IRouter iRouter) {
        super(showMarker, context);
        this.iRouter = iRouter;
        this.showMarker = showMarker;
    }

    /**
     * 初始化颜色选中
     */
    @Override
    protected boolean initColorsSelect() {
        boolean rst = super.initColorsSelect();
        if (rst) {
            if (disposableOfColorAllChange != null) {
                disposableOfColorAllChange.dispose();
            }
            disposableOfColorAllChange = iRouter.getSubjectByKey(EventKey.DrawColorAllChange)
                    .ofType(String.class)
                    .subscribe(this::handleColorAllChangeRst);
        }
        return rst;
    }

    @Override
    protected void onChangeWidth(WidthSelectData widthSelectData) {
        iRouter.getSubjectByKey(EventKey.DrawWidthChange)
                .onNext(widthSelectData);
    }

    @Override
    protected void onChangeColor(ColorSelectData colorSelectData) {
        iRouter.setObjectByKey(EventKey.IsChangedPaintColor, true);
        iRouter.getSubjectByKey(EventKey.DrawColorChange).onNext(colorSelectData);
    }

    public void onDestroy() {
        if (disposableOfColorAllChange != null) {
            disposableOfColorAllChange.dispose();
            disposableOfColorAllChange = null;
        }
    }
}
