package com.baijiayun.groupclassui.window.toolbox.quiz;

import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.IRouter;

/**
 * Created by wangkangfei on 17/5/31.
 */
public class QuizPresenter implements QuizContract.Presenter {
    private QuizContract.View view;
    private IRouter router;

    public QuizPresenter(QuizContract.View view) {
        this.view = view;
    }

    @Override
    public void setRouter(IRouter iRouter) {
        this. router = iRouter;
    }

    @Override
    public void subscribe() {
        // do nothing
    }

    @Override
    public void unSubscribe() {
        // do nothing
    }

    @Override
    public void destroy() {
        view = null;
        router = null;
    }

    @Override
    public void submitAnswer(String submitContent) {
        router.getLiveRoom().getQuizVM().sendSubmit(submitContent);
    }

    @Override
    public void sendCommonRequest(String request) {
        router.getLiveRoom().sendJSCommonRoomRequest(request);
    }

    @Override
    public void getCurrentUser() {
        view.onGetCurrentUser(router.getLiveRoom().getCurrentUser());
    }

    @Override
    public String getRoomToken() {
        return router.getLiveRoom().getQuizVM().getRoomToken();
    }

    @Override
    public void dismissDlg(boolean isSolution) {
        if (router != null) {
            router.getSubjectByKey(EventKey.CloseQuizDialog).onNext(isSolution);
        }
    }

    @Override
    public boolean checkRouterNull() {
        return router == null;
    }
}
